﻿using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using System.Web.Mvc;
using DancingGoat.Controllers.Widgets;
using DancingGoat.Models.KCContentTypes;
using DancingGoat.Models.Widgets.KCCafeWidget;

using Kentico.PageBuilder.Web.Mvc;
using KenticoCloud.Delivery;

[assembly: RegisterWidget("DancingGoat.Widgets.KCCafeWidget", typeof(KCCafeWidgetController), "KC Cafes", IconClass = "icon-octothorpe")]
namespace DancingGoat.Controllers.Widgets
{
    public class KCCafeWidgetController : WidgetController<KCCafeWidgetProperties>
    {
        public static readonly IDeliveryClient baseClient = DeliveryClientBuilder.WithProjectId("<KenticoCloudprojectID>").Build();
        public ActionResult Index()
        {
            KCCafeWidgetProperties properties = GetProperties();

            var syncContext = SynchronizationContext.Current;
            SynchronizationContext.SetSynchronizationContext(null);

            var response = baseClient.GetItemsAsync<KCCafe>(
                new EqualsFilter("system.type", "cafe"),
                new OrderParameter("system.name"),
                new LimitParameter(properties.Number)
            ).Result;
            SynchronizationContext.SetSynchronizationContext(syncContext);

            var viewModel = new KCCafeWidgetViewModel
            {
                KCCafes = response.Items.ToList()
            };

            return PartialView("Widgets/_KCCafeWidget", viewModel);
        }
    }
}